routes/web.php
<?php

use App\Http\Controllers\Admin;
use App\Http\Controllers\AppointmentController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\AvailabilityController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\WishlistController;
use App\Http\Controllers\FrontCategoryController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CommandeController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\Auth\PasswordController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProfilClientController;
use App\Http\Controllers\RecetteController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\ConseilController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\RatingController;
use App\Http\Controllers\SettingController;
use App\Http\Controllers\GestionInformationController;
use App\Http\Controllers\FrontController;
use App\Models\User;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Mail;

Route::get('/', [\App\Http\Controllers\HomeController::class, 'index'])->name('welcome');
// Routes accessibles à tous les utilisateurs
Auth::routes(['reset' => true]);
Route::get('logout', [LoginController::class, 'logout'])->name('admin.logout');
Route::post('/logout', [LoginController::class, 'logout'])->name('logout');
//MAIL REST PASSWORD
Route::post('password/reset' , [\App\Http\Controllers\Auth\ResetPasswordController::class, 'resetPassword'])->name('password.update');
Route::get('/test-email', function () {
    Mail::raw('This is a test email', function ($message) {
        $message->to('recipient@example.com')
            ->subject('Test Email from Laravel');
    });

    return 'Test email sent.';
});
//

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/nutritionnistes', [FrontController::class, 'nutritionnistes'])->name('front.nutritionnistes.index');
Route::get('/nutritionnistes/search', [FrontController::class, 'searchNutritionnistes'])->name('nutritionnistes.search');
Route::get('/recettes/search', 'App\Http\Controllers\FrontController@search')->name('recette.search');

//category recette
Route::get('/category/{slug}',[App\Http\Controllers\FrontCategoryController::class, 'index'])->name('category.recette');

//route wishlist
Route::get('/wishlist', [WishlistController::class, 'index'])->name('wishlist');
Route::post('/wishlist/add/{id}', [WishlistController::class, 'add'])->name('wishlist.add')->middleware('auth');
Route::delete('/supprimer/item/wishlist/{id}', [WishlistController::class, 'delete'])->name('wishlist.remove')->middleware('auth');

//route rating

Route::post('/products/{product}/rate', [RatingController::class, 'storeProductRating'])->name('products.rate');
Route::post('/nutritionists/rate', [RatingController::class, 'storeNutritionistRating'])->name('nutritionists.rate');

Route::get('/recette', [FrontController::class, 'recettes'])->name('front.recettes.index');
Route::get('/recettes/{id}', [FrontController::class, 'recettedetails'])->name('front.recettedetails.index');
Route::get('/conseils', [FrontController::class, 'conseil'])->name('conseils');
Route::get('/conseils/{id}', [FrontController::class, 'conseildetails'])->name('front.conseildetails.index');
Route::get('/conseils/search', [FrontController::class, 'searchConseils'])->name('conseils.search');

Route::post('/conseils/{id}/comment', [App\Http\Controllers\CommentController::class, 'createConseil'])->name('comment.create.conseil');
Route::get('/shop',[FrontController::class,'shop'])->name('shop');
Route::get('/shop/search', [FrontController::class, 'shop'])->name('shop.search');
Route::get('/shop/{id}',[FrontController::class,'shopdetails'])->name('shopdetails.index');

Route::post('ajout/commande',[CommandeController::class,'store'])->name('commande.store')->middleware('auth');
Route::get('caisse',[CommandeController::class,'index'])->name('front.caisse.index')->middleware('auth');
//route cart
Route::get('/cart',[CartController::class,'index'])->name('cart.index')->middleware('auth');
Route::post('/ajout-cart/{id}', [CartController::class, 'ajout'])->name('ajout.cart');
Route::get('/supprimer/item/cart/{id}',[CartController::class,'delete'])->name('supprimer.cart')->middleware('auth');
Route::post('/edit/{id}',[CartController::class,'update'])->name('modifier.cart')->middleware('auth');


Route::post('/appointment', [AppointmentController::class, 'create'])->name('appointment.store');
Route::resource('appointments', AppointmentController::class);
Route::get('/api/appointments', [AppointmentController::class, 'apiAppointments'])->name('api.appointments');
Route::get('/appointments/list', [AppointmentController::class, 'listAppointments'])->name('appointments.list');
Route::resource('availabilities', AvailabilityController::class);

Route::put('/nutritionnistes/{nutritionniste}/approve', [\App\Http\Controllers\NutritionnisteController::class, 'approve'])->name('nutritionnistes.approve');
Route::patch('/nutritionniste/approve', [\App\Http\Controllers\NutritionnisteController::class, 'nutritionniste'])->name('approve.nutritionniste');
Route::get('/apropos', [App\Http\Controllers\FrontController::class, 'apropos'])->name('apropos');
Route::post('/recettes/{id}/comment', [App\Http\Controllers\CommentController::class, 'create'])->name('comment.create');

Route::get('profile', [\App\Http\Controllers\ProfileController::class, 'edit'])->name('admin.profile.edit');
Route::patch('profile', [\App\Http\Controllers\ProfileController::class, 'update'])->name('admin.profile.update');
Route::patch('modifier/password', [\App\Http\Controllers\Auth\PasswordController::class, 'update'])->name('password.update');



    Route::get('user/account', [ProfilClientController::class, 'edit'])->name('client.account.edit');
    Route::patch('user/account/edit', [ProfilClientController::class, 'update'])->name('client.account.update');
    Route::patch('account/password', [ProfilClientController::class, 'updatePassword'])->name('password.update.account');

    //Route access admin
Route::prefix('admin')->middleware('auth','admin')->group(function () {
   //Route settings
    Route::get('/paramettre', [SettingController::class, 'index'])->name('settings.index');
    Route::put('/paramettre/{settings}', [SettingController::class, 'update'])->name('settings.update');
//Route auteurs
    Route::resource('nutritionniste', App\Http\Controllers\NutritionnisteController::class)->shallow();
    Route::resource('client', App\Http\Controllers\clientController::class)->shallow();
//Route categories
    Route::resource('/category', CategoryController::class)->except(['show']);
//Route produits
    Route::resource('/produit', ProductController::class);
    //Route commande-cote-admin
    Route::get('/commandes',[\App\Http\Controllers\CommandeController::class, 'Admin'])->name('commande.admin');
    Route::delete('/admin/commandes/{id}', [CommandeController::class, 'destroy'])->name('admin.commandes.destroy');
    Route::get('/commande/voir/{id}',[\App\Http\Controllers\CommandeController::class, 'show'])->name('commande.voir');
    Route::get('commandes/confirm/{id}', [CommandeController::class, 'confirm'])->name('admin.commandes.confirm');
    Route::get('commandes/annuler/{id}', [CommandeController::class, 'annuler'])->name('admin.commandes.annuler');

});

//Route admin-nutritionniste
Route::prefix('dashboard')->middleware(['auth', 'CheckRole:' . User::TYPE_SUPER_ADMIN . ',' . User::TYPE_NUTRITIONNISTE])->group(function () {
    Route::get('/acceuil', [DashboardController::class, 'index'])->name('admin.dashboard');
    Route::resource('conseil', App\Http\Controllers\ConseilController::class);
    // Route::resource('client', ClientController::class)->except(['show']);
    Route::resource('/recette', RecetteController::class);
//Route commentaires
    Route::get('/comment', [\App\Http\Controllers\CommentController::class,'index'])->name('comment.index');
    Route::put('/comment/update/{comment}',[CommentController::class,'update'])->name('comment.update');
    Route::put('/comment/debloque/{id}',[CommentController::class,'debloquer'])->name('comment.debloquer');

});

//Route Nuutritionniste
Route::prefix('nutritionniste')->middleware('auth','Nutritionniste')->group(function () {
    Route::resource('/compte', GestionInformationController::class);

});
// Routes pour les utilisateurs invités (non connectés)
Route::middleware('guest')->group(function () {

    Route::get('login', [LoginController::class, 'showLoginForm'])->name('login');
    Route::get('password/reset', [\App\Http\Controllers\Auth\ResetPasswordController::class, 'showReset'])->name('password.request');
    Route::post('login', [LoginController::class, 'login'])->name('admin.login.submit');
});

app/Models/Recettes.php
<?php

namespace App\Models;

use Conner\Tagging\Taggable;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Storage;
use Spatie\Sluggable\HasSlug;
use Spatie\Sluggable\SlugOptions;


class Recettes extends Model
{
    use HasFactory,HasSlug,Taggable;
    protected $fillable = ['title','slug','image','description','ingrédient','isActive','isComment','category_id','user_id'];


    public function getSlugOptions(): SlugOptions
    {
        return SlugOptions::create()
            ->generateSlugsFrom('title')
            ->saveSlugsTo('slug');
    }
    public function getRouteKeyName(): string
    {
        return 'slug';
    }

    public function imageUrl():string
    {
      return storage::url($this->image);
    }


    public function category():BelongsTo
    {
      return $this->belongsTo(Category::class, 'category_id','id');
    }
    public function user():BelongsTo
    {
      return $this->belongsTo(User::class, 'user_id','id');
    }
    public function comment()
    {
        return $this->hasMany(Comment::class ,'recettes_id','id')
            ->where('isActive', 1);
    }
}

app/Http/Controllers/RecetteController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Models\Recettes;
use App\Models\User;
use App\Repositories\CommentRepository;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Validator;

class RecetteController extends Controller
{
    public function __construct(CommentRepository $commentRepository)
    {
        $this->commentRepository = $commentRepository;
    }

    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        if (Auth::check() && Auth::user()->type === User::TYPE_SUPER_ADMIN) {
            $recettes = Recettes::all()->sortByDesc('created_at');
        } else {
            $recettes = Recettes::where('user_id', Auth::user()->id)->orderByDesc('created_at')->get();
        }

        return view('recette.index', compact('recettes'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('recette.create',
            [
                'categories' => Category::where('isActive', 1)->get()
            ]);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $validatedData = $request->validate([
            'title' => 'required|string|max:255',
            'description' => 'required|string',
            'ingrédient' => 'required|string',
            'isActive' => 'required|boolean',
            'isComment' => 'required|boolean',
            'image' => 'nullable|image|max:2048',
            'category_id' => ['required', 'exists:categories,id'],
        ]);

        $imagePath = null;


        if ($request->hasFile('image')) {

            // Store new avatar
            $file = $request->file('image');
            $file_name = date('YmdHis') . '.' . $file->getClientOriginalExtension();
            $file->move(public_path('images'), $file_name);
            $imagePath = 'images/' . $file_name;
        }

        /*   if ($request->hasFile('image')) {
               $image = $request->file('image');
               $imagePath = $image->store('asset', 'public');
           }*/

        $tags = explode(',', $request->tags);

        $recette = Recettes::create([
            'title' => $validatedData['title'],
            'description' => $validatedData['description'],
            'ingrédient' => $validatedData['ingrédient'],
            'isActive' => $validatedData['isActive'],
            'isComment' => $validatedData['isComment'],
            'image' => $imagePath,
            'category_id' => $validatedData['category_id'],
            'user_id' => Auth::user()->id,
        ]);
        $recette->tag($tags);
        return redirect()->route('recette.index')->with('success', 'Recette ajoutée avec succès');
    }


    /**
     * Display the specified resource.
     */
    public function show(Recettes $recette)
    {
        return view('recette.show', ['recette' => $recette]);
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Recettes $recette)
    {
        $categories = Category::where('isActive', 1)->get();
        return view('recette.edit', compact('recette', 'categories'));
    }


    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, $id)
    {
        $recette = Recettes::findOrFail($id);


        $validatedData = $request->validate([
            'title' => ['string', 'max:255'],
            'description' => ['string', 'required'],
            'image' => ['image', 'nullable', 'mimes:jpg,png,jpeg', 'max:2048'],
            'is_active' => ['required', 'boolean'],
            'is_comment' => ['required', 'boolean'],
            'is_shareable' => ['required', 'boolean'],
            'category_id' => ['required', 'exists:categories,id'],
            'tags' => ['string', 'nullable']
        ]);

        $image = $recette->image;

        if ($request->hasFile('image') && $request->file('image')->isValid()) {

            // Store new avatar
            $file = $request->file('image');
            $file_name = date('YmdHis') . '.' . $file->getClientOriginalExtension();
            $file->move(public_path('images'), $file_name);
            $imagePath = 'images/' . $file_name;

        }

        $recette->update([
            'title' => $validatedData['title'],
            'description' => $validatedData['description'],
            'is_active' => $validatedData['is_active'],
            'is_shareable' => $validatedData['is_shareable'],
            'is_comment' => $validatedData['is_comment'],
            'image' => $imagePath ?? $recette->image,
            'category_id' => $validatedData['category_id'],
            'tags' => $validatedData['tags'],

        ]);

        // Mise à jour des tags
        $tags = explode(',', $request->tags);
        $recette->retag($tags);

        return redirect()->route('recette.index')->with('success', 'Recette mise à jour avec succès');
    }


    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Recettes $recette)
    {
        $recette->delete();

        return redirect()->route('recette.index')->with('success', 'Recette supprimé avec succes');
    }

    public function comment(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'content' => 'required|string',
        ]);

        $recette = Recettes::findOrFail($id);


        if ($validator->fails()) {
            return redirect()->back()
                ->withErrors($validator)
                ->withInput()
                ->with('error', 'Il y a des erreurs de validation.');
        }

        // Si la validation réussit, continuez à créer le commentaire
        $data = $validator->validated();

        $data = [
            'recettes_id' => $recette->id,
            'content' => $request->get('content'),
            'user_id' => Auth::id()
        ];
        $comments = $this->commentRepository->create($data);

        // Passez la recette, la catégorie et le message de succès à la vue
        return redirect()->back()->with('success', 'Commentaire ajouté avec succès!')->with(compact('recette', 'comments'));
    }
}

resources/views/recette/create.blade.php
@extends('layouts.admin.app')
@section('title', "liste des recettes")
@section('dashboard-header')
    <div class="row align-items-center">
        <div class="col">
            <h3 class="page-title mt-5">Ajouter une recette</h3> </div>
    </div>
@endsection
@section('dashboard-content')
    <div class="row">
        <div class="col-lg-12">
            <form action="{{route("recette.store")}}"  method="POST" enctype="multipart/form-data">
                @csrf
                @if ($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach ($errors->all() as $error)
                                <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                @endif
                <div class="row formtype">
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Titre de l'article</label>
                            <input
                                class="form-control"
                                type="text"
                                name="title"
                                value=""
                            />
                            @error('title')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Categorie</label>
                            <select class="form-control" id="sel1" name="category_id">
                                @foreach($categories as $category)
                                    <option value="{{$category->id}}">{{$category->name}}</option>
                                @endforeach
                            </select>
                            @error('category_id')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>

                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Uploader une image</label>
                            <div class="custom-file mb-3">
                                <input
                                    type="file"
                                    class="custom-file-input"
                                    id="customFile"
                                    name="image"
                                />
                                <label class="custom-file-label" for="customFile"
                                >Choisir une image</label
                                >
                            </div>
                        </div>
                    </div>
                     <div class="col-md-4">
                     <div class="form-group">
                        <label>ingrédient</label>
                      <textarea
                        class="form-control"
                        rows="4"
                        id="comment"
                        name="ingrédient">
                      </textarea>
                         @error('ingrédient')
                         <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                         @enderror
                     </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Description</label>
                    <textarea
                        class="form-control"
                        rows="5"
                        id="comment"
                        name="description">
                  </textarea>
                            @error('description')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div></div>

                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Tags</label>
                    <div class="col-md-12 mt-3">
                        <input class="form-control" type="text" data-role="tagsinput" name="tags">
                        @if($errors->has('tags'))
                            <span class="text-danger">{{ $errors->first('tags') }}</span>
                        @endif
                   </div>
                        </div></div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Publication</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input  class="form-check-input" type="radio" id="article_active" name="isActive" value="1" checked>
                            <label class="form-check-label" for="article_active">Publier</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input  class="form-check-input" type="radio" id="article_inactive" name="isActive" value="0">
                            <label class="form-check-label" for="article_inactive">Ne pas publier</label>
                        </div>
                    </div>

                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Commentaires</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input  class="form-check-input" type="radio" id="article_comment_active" name="isComment" value="1" checked>
                            <label class="form-check-label" for="article_comment_active">Autorise</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input  class="form-check-input" type="radio" id="article_comment_inactive" name="isComment" value="0">
                            <label class="form-check-label" for="article_comment_inactive">Non autorise</label>
                        </div>
                    </div>
                    <button type="submit" class="btn btn-primary buttonedit1">Enregistrer</button>
                </div>

            </form>
        </div>
    </div>

@endsection

resources/views/recette/edit.blade.php
@extends('layouts.admin.app')

@section('title', 'Modification de recette')

@section('dashboard-header')
    <div class="row align-items-center">
        <div class="col">
            <h3 class="page-title mt-5">Modifier une recette</h3>
        </div>
    </div>
@endsection

@section('dashboard-content')
    <div class="row">
        <div class="col-lg-12">
                <form action="{{ route('recette.update', $recette->id) }}" method="POST" enctype="multipart/form-data">

                @csrf
                @method('PUT')
                <div class="row formtype">
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Titre de recette</label>
                            <input class="form-control" type="text" name="title" value="{{ old('title', $recette->title) }}">
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Categorie</label>
                            <select class="form-control" id="sel1" name="category_id">
                                @foreach($categories as $category)
                                    <option value="{{ $category->id }}" {{ $recette->category_id == $category->id ? 'selected' : '' }}>
                                        {{ $category->name }}
                                    </option>
                                @endforeach
                            </select>
                        </div>
                    </div>

                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Uploader une image</label>
                            <div class="custom-file mb-3">
                                <input type="file" class="custom-file-input" id="customFile" name="image">
                                <label class="custom-file-label" for="customFile">Choisir une image</label>
                            </div>
                        </div>
                    </div>

                    <div class="col-md-12">
                        <div class="form-group">
                            <label>Description</label>
                            <textarea class="form-control" rows="5" name="description">{{ old('description', $recette->description) }}</textarea>
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>ingrédient</label>
                            <textarea class="form-control" rows="5" name="description">{{ old('ingrédient', $recette->ingrédient) }}</textarea>
                        </div>
                    </div>
                    @if(isset($recette))
                        <div class="col-md-12 mt-3">
                            @foreach($recette->tags as $tag)
                                <label class="label label-info btn btn-primary">{{ $tag->name }}</label>
                            @endforeach
                        </div>
                    @endif
                    <div class="col-md-12 mt-3">
                        <input class="form-control" type="text" data-role="tagsinput" name="tags">
                        @if($errors->has('tags'))
                            <span class="text-danger">{{ $errors->first('tags') }}</span>
                        @endif
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Publication</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input class="form-check-input" type="radio" id="article_active" name="is_active" value="1"{{ old('is_active', $recette->is_active) == 1 ? 'checked' : '' }}>
                            <label class="form-check-label" for="article_active">Publier</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input class="form-check-input" type="radio" id="article_inactive" name="is_active" value="0"{{ old('is_active', $recette->is_active) == 0 ? 'checked' : '' }}>
                            <label class="form-check-label" for="article_inactive">Ne pas publier</label>
                        </div>
                    </div>

                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Partages</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input type="radio" class="form-check-input" id="article_share_active" name="is_shareable" value="1" {{ old('is_shareable', $recette->is_shareable) == 1 ? 'checked' : '' }}>
                            <label class="form-check-label" for="article_share_active">Partageable</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input type="radio" class="form-check-input" id="article_share_inactive" name="is_shareable" value="0" {{ old('is_shareable', $recette->is_shareable) == 0 ? 'checked' : '' }}>
                            <label class="form-check-label" for="article_share_inactive">Non Partageable</label>
                        </div>
                    </div>

                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Commentaires</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input type="radio" class="form-check-input" id="article_comment_active" name="is_comment" value="1" {{ old('is_comment', $recette->is_comment) == 1 ? 'checked' : '' }}>
                            <label class="form-check-label" for="article_comment_active">Autorise</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input type="radio" class="form-check-input" id="article_comment_inactive" name="is_comment" value="0" {{ old('is_comment', $recette->is_comment) == 0 ? 'checked' : '' }}>
                            <label class="form-check-label" for="article_comment_inactive">Non autorise</label>
                        </div>
                    </div>

                </div>
                <button type="submit" class="btn btn-primary buttonedit1">Enregistrer recette</button>
            </form>
        </div>
    </div>
@endsection